#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define ID_JUAN		0x01
#define ID_GEORGE	0x02
#define ID_HOMER	0x03
#define ID_STALIN	0x04
#define ID_ERIK		0x05
#define ID_FABIAN	0x06
#define ID_BORIS	0x07
#define ID_JOHNY	0x08
#define ID_CHARLES	0x09
#define	ID_PHIL		0x0a
#define ID_SEB		0x0b

#define CHARACTERS	0x0b

char *table[CHARACTERS] = {
	"xD",":o","~(_:(|)","<3",";-(","(:",":-?",":-P",";_;","@_@","^___~"
};

void getword(char *s) {
	int c,i=0;

	do {
		c = getchar();
	} while(isspace(c));
	if(c == EOF) {
		s[i] = 0;
		return;
	}
	do {
		s[i++] = c;
		c = getchar();
	} while(!isspace(c));
	s[i] = 0;
}

void getstring(char *s) {
	int c,i=0;

	do {
		c = getchar();
	} while(c != '\"');
	do {
		c = getchar();
		s[i++] = c;
	} while(c != '\"');
	s[--i] = 0;
}

int getid(char *s) {
	int i;

	for(i=0;i<CHARACTERS;i++) {
		if(!strcmp(s,table[i])) return i+1;
	}
	return 0;
}

int main(void) {
	char word[0x40];
	char string[0x80];
	int id,id2,id3,i,tmp=0;

	printf(	" .extern _main\n"
			" .sect .text\n"
			"_main:\n"
			" mov edi,thoughts1\n"
			" mov ecx,0x%x\n"
			" xor eax,eax\n"
			" rep\n"
			" stos\n\n",0x20*CHARACTERS);
	while(!feof(stdin)) {
		getword(word);
		if(word[0] == 0) break;
		if(!strcmp(word,"^")) {
			getword(word);
			id = getid(word);
			printf("home%d:\n",id);
		} else
		if(!strcmp(word,".oO(")) {
			getstring(string);
			getword(word);
			getword(word);
			id = getid(word);
			printf(	" push tmp%d\n"
					" push thoughts%d\n"
					" call _strcpy\n"
					" add esp,8\n"
					" .sect .data\n"
					"tmp%d:\n"
					" .asciz \"%s\"\n"
					" .sect .text\n",tmp,id,tmp,string);
			tmp++;
		} else {
		id = getid(word);
		printf("\n");
		switch(id) {
		case 0:
			fprintf(stderr,"Invalid character: \"%s\"\n",word);
			return;
		case ID_JUAN:
			getword(word);
			id2 = getid(word);
			getword(word);
			id3 = getid(word);
			printf(	" push thoughts%d\n"
					" call _atoi\n"
					" add esp,4\n"
					" push eax\n"
					" push thoughts%d\n"
					" call _atoi\n"
					" add esp,4\n"
					" pop ecx\n"
					" add eax,ecx\n"
					" push eax\n"
					" push intstr\n"
					" push thoughts%d\n"
					" call _sprintf\n"
					" add esp,12\n",id2,id3,ID_JUAN);
			break;
		case ID_GEORGE:
			getword(word);
			id2 = getid(word);
			printf(	" push thoughts%d\n"
					" call _printf\n"
					" add esp,4\n"
					" push 0x0a\n"
					" call _putchar\n"
					" add esp,4\n",id2);
			break;
		case ID_HOMER:
			printf(	" jmp end_of_prog\n");
			break;
		case ID_STALIN:
			getword(word);
			id = getid(word);
			getword(word);
			id2 = getid(word);
			getword(word);
			id3 = getid(word);
			printf(	" push thoughts%d\n"
					" push thoughts%d\n"
					" call _strcmp\n"
					" add esp,8\n"
					" or eax,eax\n"
					" jnz tmp%d\n"
					" jmp home%d\n"
					"tmp%d:\n",id,id2,tmp,id3,tmp);
			tmp++;
			break;
		case ID_ERIK:
			getword(word);
			id = getid(word);
			printf(	" push thoughts%d\n"
					" call _atoi\n"
					" neg eax\n"
					" push eax\n"
					" push intstr\n"
					" push thoughts%d\n"
					" call _sprintf\n"
					" add esp,12\n",id,id);
			break;
		case ID_FABIAN:
			getword(word);
			id = getid(word);
			printf(	" jmp home%d\n",id);
			break;
		case ID_BORIS:
			printf(	" push thoughts%d\n"
					" call _gets\n",ID_BORIS);
			break;
		case ID_JOHNY:
			getword(word);
			id = getid(word);
			getword(word);
			id2 = getid(word);
			printf(	" push thoughts%d\n"
					" push thoughts%d\n"
					" call _strcpy\n"
					" add esp,8\n",id,id2);
			break;
		case ID_CHARLES:
			printf(	" push errmsg\n"
					" call _printf\n"
					" add esp,4\n"
					" push 0x0a\n"
					" call _putchar\n"
					" add esp,4\n"
					" push 1\n"
					" call _exit\n");
			break;
		case ID_PHIL:
			getword(word);
			id = getid(word);
			getword(word);
			id2 = getid(word);
			printf(	" push thoughts%d\n"
					" call _atoi\n"
					" add esp,4\n"
					" movb al,thoughts%d(eax)\n"
					" movb (thoughts%d),al\n",id2,id,ID_PHIL);
			break;
		case ID_SEB:
			getword(word);
			id = getid(word);
			getword(word);
			id2 = getid(word);
			printf(	" push thoughts%d\n"
					" call _atoi\n"
					" add esp,4\n"
					" movb cl,(thoughts%d)\n"
					" movb thoughts%d(eax),cl\n",id2,ID_SEB,id);
			break;
		};
		}
	}
	printf(	"\nend_of_prog:\n"
			" push 0\n"
			" call _exit\n\n"
			" .sect .data\n\n"
			"errmsg:\n"
			" .asciz \"An error occured, Charles is crying!\"\n"
			"intstr:\n"
			" .asciz \"%%d\"\n");


	printf(	"\n .sect .bss\n\n");
	for(i=0;i<CHARACTERS;i++) {
		printf("thoughts%d:\n .space 0x80\n",i+1);
	}
	return 0;
}

